<?php
/*
 * UPDATE SCRIPT FOR kOOL RELEASE R40
 *
 * Description:
 * Adds the new column ko_leute.smallgroups and converts the smallgroup memberships from kg and kg_leiter.
 * Converts all filter presets from people module containing an old filter for columns kg or kg_leiter
 *
 * Instructions:
 * - Make sure your SQL user account used for kOOL has ALTER rights.
 * - Set the path to your kOOL installation below and run the script on your kOOL server.
 * - Set $delete_columns to TRUE or manually delete the old columns ko_leute.kg and ko_leute.kg_leiter after updating
 *
 */


/* Settings */

// Set path to your kOOL installation (absolute or relative)
$kOOL_path = '/var/www/kOOL_demo/';

// Delete db columns after update
// Set to TRUE to do it automatically. Leave it to FALSE to manually delete ko_leute.kg and ko_leute.kg_leiter
$delete_columns = TRUE;

/* End of settings */



// Include ko.inc (and with it database settings from ko-config.php)
$ko_path = $kOOL_path;
require_once($kOOL_path.'inc/ko.inc');




// Add new column ko_leute.smallgroups
$result = mysql_query('ALTER TABLE `ko_leute` ADD `smallgroups` TEXT NOT NULL AFTER `kg_leiter`');
if(!$result) {
	die('ERROR: Not able to ALTER TABLE ko_leute, please check access rights.'."\n");
}


// Get all current smallgroup members and leaders
$kg_members = db_select_data("ko_leute", "WHERE (`kg` != '' OR `kg_leiter` != '')", "id,kg,kg_leiter");
foreach($kg_members as $member) {
	unset($smallgroups);
	// Store membership
	foreach(explode(",", $member["kg"]) as $kgid) {
		if(!$kgid) continue;
		$smallgroups[] = $kgid.':M';
	}
	// Store leadership
	foreach(explode(",", $member["kg_leiter"]) as $kgid) {
		if(!$kgid) continue;
		$smallgroups[] = $kgid.':L';
	}

	// Update ko_leute.smallgroups with new smallgroups infos
	db_update_data('ko_leute', "WHERE `id` = '".$member['id']."'", array('smallgroups' => implode(',', $smallgroups)));
}

// Delete old columns from ko_leute
if($delete_columns) mysql_query('ALTER TABLE `ko_leute` DROP `kg`, DROP `kg_leiter`');






// Update filter presets containing an old smallgroup or smallgroup leader filter

// Update kg filter and add new filter for smallgroup roles
mysql_query("UPDATE `ko_filter` SET `sql1` = 'smallgroups REGEXP ''[VAR1]''' WHERE `name` = 'smallgroup'");
mysql_query("INSERT INTO `ko_filter` ( `id` , `typ` , `dbcol` , `name` , `allow_neg` , `sql1` , `sql2` , `sql3` , `numvars` , `var1` , `code1` , `var2` , `code2` , `var3` , `code3`) VALUES ( NULL , 'leute', '', 'smallgrouproles', '1', 'smallgroups REGEXP '':[VAR1]''', '', '', '1', 'smallgroup role', 'FCN:ko_specialfilter_smallgrouproles', '', '', '', '')");

// Get IDs of smallgroup filters
$filter = db_select_data('ko_filter', "WHERE `name` = 'smallgroup'", '*', '', '', TRUE);
$fid_kg = $filter['id'];
$filter = db_select_data('ko_filter', "WHERE `name` = 'smallgroup leader'", '*', '', '', TRUE);
$fid_kgl = $filter['id'];
$filter = db_select_data('ko_filter', "WHERE `name` = 'smallgrouproles'", '*', '', '', TRUE);
$fid_kgr = $filter['id'];


// Get all filter presets
$presets = db_select_data('ko_userprefs', "WHERE `type` = 'filterset'", '*', '', '', FALSE, TRUE);
foreach($presets as $preset) {
  $update = FALSE;
  $filter = unserialize($preset['value']);
  $new = $filter;
  // Check filters in preset for old smallgroup and smallgroup leader filters
  foreach($filter as $id => $f) {
    if(!is_integer($id)) continue;

    // smallgroup
    if($f[0] == $fid_kg) {
      //All members
      if($f[1][1] == '' && $f[2] == 1) {
        $new[$id][0] = $fid_kgr;  //Change to smallgroup roles filter
        $new[$id][1][1] = 'M';    //Member role
        $new[$id][2] = 0;
        $update = TRUE;
      }
      //Others (''|0 and ID) don't need any changes
    }

    // smallgroup leader
    else if($f[0] == $fid_kgl) {
      // All leaders
      if($f[1][1] == '' && $f[2] == 1) {
        $new[$id][0] = $fid_kgr;  //Change to smallgroup roles filter
        $new[$id][1][1] = 'L';    //Leader role
        $new[$id][2] = 0;
        $update = TRUE;
			}
			// All non-leaders
			else if($f[1][1] == '' && $f[2] == 0) {
        $new[$id][0] = $fid_kgr;  //Change to smallgroup roles filter
        $new[$id][1][1] = 'L';    //Leader role
        $new[$id][2] = 1;         //Activate negative to get all non-leaders
        $update = TRUE;
			}
    }

  }//foreach(filter as id => f)

  // Update filter preset if necessary
  if($update) {
		db_update_data('ko_userprefs',
									 "WHERE `user_id` = '".$preset['user_id']."' AND `type` = '".$preset['type']."' AND `key` = '".$preset['key']."'",
									 array('value' => serialize($new))
    );
  }

}

// Delete old kg_leiter filter
mysql_query("DELETE FROM `ko_filter` WHERE `name` = 'smallgroup leader'");





// Update column presets that hold an old column (kg or kg_leiter)
$presets = db_select_data('ko_userprefs', "WHERE `type` = 'leute_itemset' AND (`value` REGEXP '(^|,)kg(,|$)' OR `value` REGEXP '(^|,)kg_leiter(,|$)')");
foreach($presets as $preset) {
	$new = array();
	foreach(explode(',', $preset['value']) as $key) {
		if(!$key) continue;
		if($key == 'kg' || $key == 'kg_leiter') {
			$new[] = 'smallgroups';
		} else {
			$new[] = $key;
		}
	}
	$new = array_unique($new);

	db_update_data('ko_userprefs',
								 "WHERE `user_id` = '".$preset['user_id']."' AND `type` = '".$preset['type']."' AND `key` = '".$preset['key']."'",
								 array('value' => implode(',', $new))
	);
}

?>
